diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.45/src/core/model/attribute-accessor-helper.h ns-3.46/src/core/model/attribute-accessor-helper.h
--- ns-3.45/src/core/model/attribute-accessor-helper.h	2025-06-01 20:34:45.000000000 -0700
+++ ns-3.46/src/core/model/attribute-accessor-helper.h	2025-10-01 18:46:32.000000000 -0700
@@ -233,12 +233,9 @@
  * @param [in]  memberVariable  The address of the data member.
  * @returns The AttributeAccessor.
  */
-// clang-format off
-// Clang-format guard needed for versions <= 18
 template <typename V, typename T, typename U>
 inline Ptr<const AttributeAccessor>
 DoMakeAccessorHelperOne(U T::* memberVariable)
-// clang-format on
 {
     /* AttributeAccessor implementation for a class member variable. */
     class MemberVariable : public AccessorHelper<T, V>
@@ -248,10 +245,7 @@
          * Construct from a class data member address.
          * @param [in] memberVariable The class data member address.
          */
-        // clang-format off
-        // Clang-format guard needed for versions <= 18
         MemberVariable(U T::* memberVariable)
-            // clang-format on
             : AccessorHelper<T, V>(),
               m_memberVariable(memberVariable)
         {
@@ -286,10 +280,7 @@
             return true;
         }
 
-        // clang-format off
-        // Clang-format guard needed for versions <= 18
         U T::* m_memberVariable; // Address of the class data member.
-        // clang-format on
     };
 
     return Ptr<const AttributeAccessor>(new MemberVariable(memberVariable), false);
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.45/src/core/model/boolean.cc ns-3.46/src/core/model/boolean.cc
--- ns-3.45/src/core/model/boolean.cc	2025-06-01 20:34:45.000000000 -0700
+++ ns-3.46/src/core/model/boolean.cc	2025-10-01 18:46:32.000000000 -0700
@@ -47,7 +47,8 @@
     return m_value;
 }
 
-BooleanValue::operator bool() const
+BooleanValue::
+operator bool() const
 {
     return m_value;
 }
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.45/src/core/model/cairo-wideint.c ns-3.46/src/core/model/cairo-wideint.c
--- ns-3.45/src/core/model/cairo-wideint.c	2025-06-01 20:34:45.000000000 -0700
+++ ns-3.46/src/core/model/cairo-wideint.c	2025-10-01 18:46:32.000000000 -0700
@@ -45,7 +45,14 @@
 
 #if HAVE_UINT64_T
 
-const char * cairo_impl64 = "uint64_t";
+//PDB original string literal causes access violation on Windows when accessed
+// by binaries that link to core, e.g. tests
+// Substitute function call
+const char *
+cairo_impl64()
+{
+    return "uint64_t";
+}
 
 #define _cairo_uint32s_to_uint64(h,l) ((uint64_t) (h) << 32 | (l))
 
@@ -61,7 +68,14 @@
 
 #else
 
-const char * cairo_impl64 = "uint32_t";
+//PDB original string literal causes access violation on Windows when accessed
+// by binaries that link to core, e.g. tests
+// Substitute function call
+const char *
+cairo_impl64()
+{
+    return "uint32_t";
+}
 
 cairo_uint64_t
 _cairo_uint32_to_uint64 (uint32_t i)
@@ -329,7 +343,14 @@
 
 #if HAVE_UINT128_T
 
-const char * cairo_impl128 = "uint128_t";
+//PDB original string literal causes access violation on Windows when accessed
+// by binaries that link to core, e.g. tests
+// Substitute function call
+const char *
+cairo_impl128()
+{
+    return "uint128_t";
+}
 
 cairo_uquorem128_t
 _cairo_uint128_divrem (cairo_uint128_t num, cairo_uint128_t den)
@@ -343,7 +364,14 @@
 
 #else
 
-const char * cairo_impl128 = "cairo_uint64_t";
+//PDB original string literal causes access violation on Windows when accessed
+// by binaries that link to core, e.g. tests
+// Substitute function call
+const char *
+cairo_impl128()
+{
+    return "cairo_uint64_t";
+}
 
 cairo_uint128_t
 _cairo_uint32_to_uint128 (uint32_t i)
@@ -550,7 +578,7 @@
 }
 
 cairo_uint128_t
-_cairo_uint128_rsa (cairo_int128_t a, int shift)
+_cairo_uint128_rsa (cairo_uint128_t a, int shift)
 {
     if (shift >= 64)
     {
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.45/src/core/model/cairo-wideint-private.h ns-3.46/src/core/model/cairo-wideint-private.h
--- ns-3.45/src/core/model/cairo-wideint-private.h	2025-06-01 20:34:45.000000000 -0700
+++ ns-3.46/src/core/model/cairo-wideint-private.h	2025-10-01 18:46:32.000000000 -0700
@@ -51,45 +51,7 @@
 // extern const char * cairo_impl64;
 // extern const char * cairo_impl128;
 
-/*for compatibility with MacOS and Cygwin*/
-#ifndef HAVE_STDINT_H
-#ifdef __APPLE__
-#define HAVE_STDINT_H 1
-#elif defined(WIN32)
-#define HAVE_STDINT_H 1
-#endif
-#endif
-
-#if   HAVE_STDINT_H
-# include <stdint.h>
-#elif HAVE_INTTYPES_H
-# include <inttypes.h>
-#elif HAVE_SYS_INT_TYPES_H
-# include <sys/int_types.h>
-#elif defined(_MSC_VER)
-typedef __int8 int8_t;
-typedef unsigned __int8 uint8_t;
-typedef __int16 int16_t;
-typedef unsigned __int16 uint16_t;
-typedef __int32 int32_t;
-typedef unsigned __int32 uint32_t;
-typedef __int64 int64_t;
-typedef unsigned __int64 uint64_t;
-# ifndef HAVE_UINT64_T
-#  define HAVE_UINT64_T 1
-# endif
-# ifndef INT16_MIN
-#  define INT16_MIN     (-32767-1)
-# endif
-# ifndef INT16_MAX
-#  define INT16_MAX     (32767)
-# endif
-# ifndef UINT16_MAX
-#  define UINT16_MAX    (65535)
-# endif
-#else
-#error Cannot find definitions for fixed-width integral types (uint8_t, uint32_t, etc.)
-#endif
+#include <cstdint> // PDB
 
 #ifdef __cplusplus
 extern "C" {
@@ -108,7 +70,10 @@
 
 #if !HAVE_UINT64_T
 
-extern const char * cairo_impl64;
+//PDB original string literal causes access violation on Windows when accessed
+// by binaries that link to core, e.g. tests
+// Substitute function call
+const char * cairo_impl64();
 
 typedef struct _cairo_uint64 {
   uint32_t    lo, hi;
@@ -149,7 +114,10 @@
 
 #else
 
-extern const char * cairo_impl64;
+//PDB original string literal causes access violation on Windows when accessed
+// by binaries that link to core, e.g. tests
+// Substitute function call
+const char * cairo_impl64();
 
 typedef uint64_t    cairo_uint64_t;
 typedef int64_t     cairo_int64_t;
@@ -231,7 +199,10 @@
 
 #if !HAVE_UINT128_T
 
-extern const char * cairo_impl128;
+//PDB original string literal causes access violation on Windows when accessed
+// by binaries that link to core, e.g. tests
+// Substitute function call
+const char * cairo_impl128();
 
 typedef struct cairo_uint128 {
   cairo_uint64_t      lo, hi;
@@ -276,7 +247,10 @@
 
 #else   /* !HAVE_UINT128_T */
 
-extern const char * cairo_impl128;
+//PDB original string literal causes access violation on Windows when accessed
+// by binaries that link to core, e.g. tests
+// Substitute function call
+const char * cairo_impl128();
 
 typedef uint128_t       cairo_uint128_t;
 typedef int128_t        cairo_int128_t;
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.45/src/core/model/deprecated.h ns-3.46/src/core/model/deprecated.h
--- ns-3.45/src/core/model/deprecated.h	2025-06-01 20:34:45.000000000 -0700
+++ ns-3.46/src/core/model/deprecated.h	2025-10-01 18:46:32.000000000 -0700
@@ -85,6 +85,13 @@
 
 /**
  * @ingroup deprecation
+ * @def NS_DEPRECATED_3_46
+ * Tag for things deprecated in version ns-3.46.
+ */
+#define NS_DEPRECATED_3_46(msg) NS_DEPRECATED("Deprecated in ns-3.46: " msg)
+
+/**
+ * @ingroup deprecation
  * @def NS_DEPRECATED_3_45
  * Tag for things deprecated in version ns-3.45.
  */
@@ -104,25 +111,4 @@
  */
 #define NS_DEPRECATED_3_43(msg) NS_DEPRECATED("Deprecated in ns-3.43: " msg)
 
-/**
- * @ingroup deprecation
- * @def NS_DEPRECATED_3_42
- * Tag for things deprecated in version ns-3.42.
- */
-#define NS_DEPRECATED_3_42(msg) NS_DEPRECATED("Deprecated in ns-3.42: " msg)
-
-/**
- * @ingroup deprecation
- * @def NS_DEPRECATED_3_41
- * Tag for things deprecated in version ns-3.41.
- */
-#define NS_DEPRECATED_3_41(msg) NS_DEPRECATED("Deprecated in ns-3.41: " msg)
-
-/**
- * @ingroup deprecation
- * @def NS_DEPRECATED_3_40
- * Tag for things deprecated in version ns-3.40.
- */
-#define NS_DEPRECATED_3_40(msg) NS_DEPRECATED("Deprecated in ns-3.40: " msg)
-
 #endif /* NS3_DEPRECATED_H */
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.45/src/core/model/environment-variable.cc ns-3.46/src/core/model/environment-variable.cc
--- ns-3.45/src/core/model/environment-variable.cc	2025-06-01 20:34:45.000000000 -0700
+++ ns-3.46/src/core/model/environment-variable.cc	2025-10-01 18:46:32.000000000 -0700
@@ -11,9 +11,9 @@
 #include "string.h"
 
 #include <cstdlib>  // std::getenv
+#include <cstdlib>  // Global functions setenv, unsetenv
 #include <cstring>  // strlen
 #include <iostream> // clog
-#include <stdlib.h> // Global functions setenv, unsetenv
 
 /**
  * @file
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.45/src/core/model/event-id.cc ns-3.46/src/core/model/event-id.cc
--- ns-3.45/src/core/model/event-id.cc	2025-06-01 20:34:45.000000000 -0700
+++ ns-3.46/src/core/model/event-id.cc	2025-10-01 18:46:32.000000000 -0700
@@ -68,12 +68,6 @@
     return !IsExpired();
 }
 
-bool
-EventId::IsRunning() const
-{
-    return IsPending();
-}
-
 EventImpl*
 EventId::PeekEventImpl() const
 {
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.45/src/core/model/event-id.h ns-3.46/src/core/model/event-id.h
--- ns-3.45/src/core/model/event-id.h	2025-06-01 20:34:45.000000000 -0700
+++ ns-3.46/src/core/model/event-id.h	2025-10-01 18:46:32.000000000 -0700
@@ -8,7 +8,6 @@
 #ifndef EVENT_ID_H
 #define EVENT_ID_H
 
-#include "deprecated.h"
 #include "event-impl.h"
 #include "ptr.h"
 
@@ -93,14 +92,6 @@
      */
     bool IsPending() const;
 
-    /**
-     * This method is syntactic sugar for !IsExpired().
-     *
-     * @returns \c true if the event has not expired, \c false otherwise.
-     */
-    NS_DEPRECATED_3_42("Use IsPending instead")
-    bool IsRunning() const;
-
   public:
     /**
      * @name Scheduler Helpers.
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.45/src/core/model/fatal-error.h ns-3.46/src/core/model/fatal-error.h
--- ns-3.45/src/core/model/fatal-error.h	2025-06-01 20:34:45.000000000 -0700
+++ ns-3.46/src/core/model/fatal-error.h	2025-10-01 18:46:32.000000000 -0700
@@ -17,6 +17,23 @@
 #include <iostream>
 #include <string_view>
 
+// If stacktrace is available, print it on fatal errors
+#ifdef STACKTRACE_LIBRARY_IS_LINKED
+#include <stacktrace>
+/**
+ * @brief Macro prints the current stack trace to standard error.
+ *
+ * This macro is defined only if the stacktrace library is linked.
+ */
+
+#define PRINT_STACKTRACE std::cerr << std::stacktrace::current() << std::endl
+#else
+/**
+ * @brief Macro does nothing if stacktrace library is not available.
+ */
+#define PRINT_STACKTRACE
+#endif
+
 /**
  * @file
  * @ingroup fatal
@@ -84,6 +101,7 @@
         if (fatal)                                                                                 \
         {                                                                                          \
             std::cerr << ns3::NS_FATAL_MSG << std::endl;                                           \
+            PRINT_STACKTRACE;                                                                      \
             std::terminate();                                                                      \
         }                                                                                          \
     } while (false)
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.45/src/core/model/hash-fnv.cc ns-3.46/src/core/model/hash-fnv.cc
--- ns-3.45/src/core/model/hash-fnv.cc	2025-06-01 20:34:45.000000000 -0700
+++ ns-3.46/src/core/model/hash-fnv.cc	2025-10-01 18:46:32.000000000 -0700
@@ -22,7 +22,7 @@
 
 #include "log.h"
 
-#include <stdlib.h>
+#include <cstdlib>
 #include <sys/types.h>
 
 /**
@@ -347,7 +347,7 @@
  * Share and Enjoy!	:-)
  */
 
-//#include <stdlib.h>    //PDB
+//#include <cstdlib>    //PDB
 //#include "fnv.h"       //PDB
 
 
@@ -495,7 +495,7 @@
  * Share and Enjoy!	:-)
  */
 
-//#include <stdlib.h>    //PDB
+//#include <cstdlib>    //PDB
 //#include "fnv.h"       //PDB
 
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.45/src/core/model/int64x64-cairo.cc ns-3.46/src/core/model/int64x64-cairo.cc
--- ns-3.45/src/core/model/int64x64-cairo.cc	2025-06-01 20:34:45.000000000 -0700
+++ ns-3.46/src/core/model/int64x64-cairo.cc	2025-10-01 18:46:32.000000000 -0700
@@ -1,3 +1,4 @@
+// NOLINTBEGIN
 /*
  * Copyright (c) 2006 INRIA
  *
@@ -228,3 +229,4 @@
 } // namespace ns3
 
 #endif /* INT64X64_CAIRO_H */
+// NOLINTEND
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.45/src/core/model/int64x64-cairo.h ns-3.46/src/core/model/int64x64-cairo.h
--- ns-3.45/src/core/model/int64x64-cairo.h	2025-06-01 20:34:45.000000000 -0700
+++ ns-3.46/src/core/model/int64x64-cairo.h	2025-10-01 18:46:32.000000000 -0700
@@ -1,3 +1,4 @@
+// NOLINTBEGIN
 /*
  * Copyright (c) 2010 INRIA
  *
@@ -435,3 +436,4 @@
 
 #endif /* defined(INT64X64_USE_CAIRO) && !defined(PYTHON_SCAN) */
 #endif /* INT64X64_CAIRO_H */
+// NOLINTEND
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.45/src/core/model/int64x64.cc ns-3.46/src/core/model/int64x64.cc
--- ns-3.45/src/core/model/int64x64.cc	2025-06-01 20:34:45.000000000 -0700
+++ ns-3.46/src/core/model/int64x64.cc	2025-10-01 18:46:32.000000000 -0700
@@ -9,11 +9,11 @@
 #include "assert.h"
 #include "log.h"
 
+#include <cstdint>
 #include <iomanip> // showpos
 #include <iostream>
 #include <limits>
 #include <sstream>
-#include <stdint.h>
 
 /**
  * @file
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.45/src/core/model/log.cc ns-3.46/src/core/model/log.cc
--- ns-3.45/src/core/model/log.cc	2025-06-01 20:34:45.000000000 -0700
+++ ns-3.46/src/core/model/log.cc	2025-10-01 18:46:32.000000000 -0700
@@ -233,13 +233,6 @@
 }
 
 bool
-LogComponent::IsEnabled(const LogLevel level) const
-{
-    //  LogComponentEnableEnvVar ();
-    return level & m_levels;
-}
-
-bool
 LogComponent::IsNoneEnabled() const
 {
     return m_levels == 0;
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.45/src/core/model/log.h ns-3.46/src/core/model/log.h
--- ns-3.45/src/core/model/log.h	2025-06-01 20:34:45.000000000 -0700
+++ ns-3.46/src/core/model/log.h	2025-10-01 18:46:32.000000000 -0700
@@ -326,13 +326,22 @@
      *                  functions which help implement the logging facility.
      */
     LogComponent(const std::string& name, const std::string& file, const LogLevel mask = LOG_NONE);
+
     /**
      * Check if this LogComponent is enabled for \c level
      *
      * @param [in] level The level to check for.
      * @return \c true if we are enabled at \c level.
+     *
+     * @internal
+     * This function is defined in the header to enable inlining for better performance. See:
+     * https://gitlab.com/nsnam/ns-3-dev/-/merge_requests/2448#note_2527898962
      */
-    bool IsEnabled(const LogLevel level) const;
+    bool IsEnabled(const LogLevel level) const
+    {
+        return level & m_levels;
+    }
+
     /**
      * Check if all levels are disabled.
      *
@@ -478,6 +487,10 @@
         // Use + unary operator to cast uint8_t / int8_t to uint32_t / int32_t, respectively
         m_os << +param;
     }
+    else if constexpr (std::is_pointer_v<T>)
+    {
+        m_os << static_cast<const void*>(&param);
+    }
     else
     {
         m_os << param;
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.45/src/core/model/matrix-array.cc ns-3.46/src/core/model/matrix-array.cc
--- ns-3.45/src/core/model/matrix-array.cc	2025-06-01 20:34:45.000000000 -0700
+++ ns-3.46/src/core/model/matrix-array.cc	2025-10-01 18:46:32.000000000 -0700
@@ -15,9 +15,16 @@
 #pragma GCC diagnostic ignored "-Wclass-memaccess"
 #pragma GCC diagnostic ignored "-Wunused-variable"
 #endif
+#if defined(__clang__)
+#pragma clang diagnostic push
+#pragma clang diagnostic ignored "-Wdeprecated-declarations"
+#endif
 
 #include <Eigen/Dense>
 
+#if defined(__clang__)
+#pragma clang diagnostic pop
+#endif
 #if defined(__GNUC__) && !defined(__clang__)
 #pragma GCC diagnostic pop
 #endif
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.45/src/core/model/nstime.h ns-3.46/src/core/model/nstime.h
--- ns-3.45/src/core/model/nstime.h	2025-06-01 20:34:45.000000000 -0700
+++ ns-3.46/src/core/model/nstime.h	2025-10-01 18:46:32.000000000 -0700
@@ -15,6 +15,8 @@
 #include "int64x64.h"
 #include "type-name.h"
 
+#include "ns3/core-export.h"
+
 #include <cmath>
 #include <limits>
 #include <ostream>
@@ -90,7 +92,7 @@
  * if you use picoseconds is 2^64 ps = 2^24 s = 7 months, whereas,
  * had you used nanoseconds, you could have run for 584 years.
  */
-class Time
+class CORE_EXPORT Time
 {
   public:
     /**
@@ -127,7 +129,7 @@
     inline Time()
         : m_data()
     {
-        if (g_markingTimes)
+        if (MarkingTimes())
         {
             Mark(this);
         }
@@ -141,7 +143,7 @@
     inline Time(const Time& o)
         : m_data(o.m_data)
     {
-        if (g_markingTimes)
+        if (MarkingTimes())
         {
             Mark(this);
         }
@@ -155,7 +157,7 @@
     Time(Time&& o)
         : m_data(o.m_data)
     {
-        if (g_markingTimes)
+        if (MarkingTimes())
         {
             Mark(this);
         }
@@ -174,7 +176,7 @@
     explicit inline Time(double v)
         : m_data(llround(v))
     {
-        if (g_markingTimes)
+        if (MarkingTimes())
         {
             Mark(this);
         }
@@ -183,7 +185,7 @@
     explicit inline Time(int v)
         : m_data(v)
     {
-        if (g_markingTimes)
+        if (MarkingTimes())
         {
             Mark(this);
         }
@@ -192,7 +194,7 @@
     explicit inline Time(long int v)
         : m_data(v)
     {
-        if (g_markingTimes)
+        if (MarkingTimes())
         {
             Mark(this);
         }
@@ -201,7 +203,7 @@
     explicit inline Time(long long int v)
         : m_data(v)
     {
-        if (g_markingTimes)
+        if (MarkingTimes())
         {
             Mark(this);
         }
@@ -210,7 +212,7 @@
     explicit inline Time(unsigned int v)
         : m_data(v)
     {
-        if (g_markingTimes)
+        if (MarkingTimes())
         {
             Mark(this);
         }
@@ -219,7 +221,7 @@
     explicit inline Time(unsigned long int v)
         : m_data(v)
     {
-        if (g_markingTimes)
+        if (MarkingTimes())
         {
             Mark(this);
         }
@@ -228,7 +230,7 @@
     explicit inline Time(unsigned long long int v)
         : m_data(v)
     {
-        if (g_markingTimes)
+        if (MarkingTimes())
         {
             Mark(this);
         }
@@ -237,7 +239,7 @@
     explicit inline Time(const int64x64_t& v)
         : m_data(v.Round())
     {
-        if (g_markingTimes)
+        if (MarkingTimes())
         {
             Mark(this);
         }
@@ -291,7 +293,7 @@
     /** Destructor */
     ~Time()
     {
-        if (g_markingTimes)
+        if (MarkingTimes())
         {
             Clear(this);
         }
@@ -746,6 +748,21 @@
      */
     static MarkedTimes* g_markingTimes;
 
+    /**
+     *  Null check for g_markingTimes from outside time.cc
+     *
+     *  @return \c true if g_markingTimes is not null
+     *
+     *  @internal
+     *
+     *  The inline Time ctors need to check if g_markingTimes is allocated
+     *  before calling Mark(). Likewise, the dtor also needs to check before
+     *  calling Clear(). On Windows, attempting to access g_markingTimes
+     *  directly from outside the compilation unit is an access violation so
+     *  this method is provided to work around that limitation.
+     */
+    static bool MarkingTimes();
+
   public:
     /**
      *  Function to force static initialization of Time.
@@ -867,6 +884,13 @@
 } // namespace TracedValueCallback
 
 /**
+ * Force static initialization order of Time in each compilation unit.
+ * This is internal to the Time implementation.
+ * @relates Time
+ */
+static bool g_TimeStaticInit [[maybe_unused]] = Time::StaticInit();
+
+/**
  * Equality operator for Time.
  * @param [in] lhs The first value
  * @param [in] rhs The second value
@@ -1510,27 +1534,6 @@
  */
 TYPENAMEGET_DEFINE(Time);
 
-/**
- * @ingroup time
- *
- * @brief Helper class to force static initialization
- * of Time in each compilation unit, ensuring it is
- * initialized before usage.
- * This is internal to the Time implementation.
- * @relates Time
- */
-class TimeInitializationHelper
-{
-  public:
-    /** Default constructor calls Time::StaticInit */
-    TimeInitializationHelper()
-    {
-        Time::StaticInit();
-    }
-};
-
-static TimeInitializationHelper g_timeInitHelper; ///< Instance of Time static initialization helper
-
 } // namespace ns3
 
 #endif /* TIME_H */
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.45/src/core/model/object-base.cc ns-3.46/src/core/model/object-base.cc
--- ns-3.45/src/core/model/object-base.cc	2025-06-01 20:34:45.000000000 -0700
+++ ns-3.46/src/core/model/object-base.cc	2025-10-01 18:46:32.000000000 -0700
@@ -83,6 +83,19 @@
     // loop over the inheritance tree back to the Object base class.
     NS_LOG_FUNCTION(this << &attributes);
     TypeId tid = GetInstanceTypeId();
+    TypeId objectTid;
+    // the TypeId of a class derived from Object is initialized to "ns3::Object"; for a class
+    // deriving from Object, check that this function is called after that the correct TypeId is set
+    // to ensure that the attributes of the class are initialized
+    NS_ABORT_MSG_IF(TypeId::LookupByNameFailSafe("ns3::Object", &objectTid) && tid == objectTid,
+                    "ObjectBase::ConstructSelf() has been called on an object of a class derived "
+                    "from the Object class, but the TypeId is still set to ns3::Object.\n"
+                    "This is known to happen in two cases:\n"
+                    "- ObjectBase::ConstructSelf() is called in the class constructor; in this "
+                    "case, override ObjectBase::NotifyConstructionCompleted() to access the "
+                    "initial values of the object attributes as soon as object construction is "
+                    "completed (see issue #1249)\n"
+                    "- the class deriving from Object does not define a static GetTypeId() method");
     do // Do this tid and all parents
     {
         // loop over all attributes in object type
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.45/src/core/model/pointer.h ns-3.46/src/core/model/pointer.h
--- ns-3.45/src/core/model/pointer.h	2025-06-01 20:34:45.000000000 -0700
+++ ns-3.46/src/core/model/pointer.h	2025-10-01 18:46:32.000000000 -0700
@@ -227,7 +227,8 @@
 }
 
 template <typename T>
-PointerValue::operator Ptr<T>() const
+PointerValue::
+operator Ptr<T>() const
 {
     return Get<T>();
 }
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.45/src/core/model/ptr.h ns-3.46/src/core/model/ptr.h
--- ns-3.45/src/core/model/ptr.h	2025-06-01 20:34:45.000000000 -0700
+++ ns-3.46/src/core/model/ptr.h	2025-10-01 18:46:32.000000000 -0700
@@ -13,6 +13,7 @@
 
 #include <iostream>
 #include <stdint.h>
+#include <type_traits>
 
 /**
  * @file
@@ -427,6 +428,8 @@
 namespace ns3
 {
 
+class Object;
+
 /*************************************************
  *  friend non-member function implementations
  ************************************************/
@@ -435,6 +438,8 @@
 Ptr<T>
 Create(Ts&&... args)
 {
+    static_assert(!std::is_base_of_v<Object, T>,
+                  "Use CreateObject() instead of Create() for Object subclasses");
     return Ptr<T>(new T(std::forward<Ts>(args)...), false);
 }
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.45/src/core/model/random-variable-stream.cc ns-3.46/src/core/model/random-variable-stream.cc
--- ns-3.45/src/core/model/random-variable-stream.cc	2025-06-01 20:34:45.000000000 -0700
+++ ns-3.46/src/core/model/random-variable-stream.cc	2025-10-01 18:46:32.000000000 -0700
@@ -652,8 +652,6 @@
 
 NS_OBJECT_ENSURE_REGISTERED(NormalRandomVariable);
 
-const double NormalRandomVariable::INFINITE_VALUE = 1e307;
-
 TypeId
 NormalRandomVariable::GetTypeId()
 {
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.45/src/core/model/random-variable-stream.h ns-3.46/src/core/model/random-variable-stream.h
--- ns-3.45/src/core/model/random-variable-stream.h	2025-06-01 20:34:45.000000000 -0700
+++ ns-3.46/src/core/model/random-variable-stream.h	2025-10-01 18:46:32.000000000 -0700
@@ -19,6 +19,7 @@
 #include "object.h"
 #include "type-id.h"
 
+#include <limits>
 #include <map>
 #include <stdint.h>
 
@@ -978,8 +979,8 @@
 class NormalRandomVariable : public RandomVariableStream
 {
   public:
-    /** Large constant to bound the range. */
-    static const double INFINITE_VALUE;
+    /// Large constant to bound the range.
+    static constexpr double INFINITE_VALUE = std::numeric_limits<double>::max();
 
     /**
      * @brief Register this type.
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.45/src/core/model/rng-stream.cc ns-3.46/src/core/model/rng-stream.cc
--- ns-3.45/src/core/model/rng-stream.cc	2025-06-01 20:34:45.000000000 -0700
+++ ns-3.46/src/core/model/rng-stream.cc	2025-10-01 18:46:32.000000000 -0700
@@ -98,7 +98,7 @@
  * \param [in] s Second multiplicative argument.
  * \param [in] c Additive argument.
  * \param [in] m Modulus.
- * \returns <tt>(a*s +c) MOD m</tt>
+ * \returns ``(a*s +c) MOD m``
  */
 double MultModM (double a, double s, double c, double m)
 {
